## pugixml 1.12.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(pugixml VERSION 1.12 LANGUAGES CXX)

include(CMakePackageConfigHelpers)
include(CMakeDependentOption)
include(GNUInstallDirs)
include(CTest)

cmake_dependent_option(PUGIXML_USE_VERSIONED_LIBDIR
  "Use a private subdirectory to install the headers and libraries" OFF
  "CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR" OFF)

cmake_dependent_option(PUGIXML_USE_POSTFIX
  "Use separate postfix for each configuration to make sure you can install multiple build outputs" OFF
  "CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR" OFF)

cmake_dependent_option(PUGIXML_STATIC_CRT
  "Use static MSVC RT libraries" OFF
  "MSVC" OFF)

cmake_dependent_option(PUGIXML_BUILD_TESTS
  "Build pugixml tests" OFF
  "BUILD_TESTING;CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR" OFF)

# Custom build defines
set(PUGIXML_BUILD_DEFINES CACHE STRING "Build defines for custom options")
separate_arguments(PUGIXML_BUILD_DEFINES)

# Technically not needed for this file. This is builtin CMAKE global variable.
option(BUILD_SHARED_LIBS "Build shared instead of static library" OFF) 

# Expose option to build PUGIXML as static as well when the global BUILD_SHARED_LIBS variable is set
cmake_dependent_option(PUGIXML_BUILD_SHARED_AND_STATIC_LIBS
  "Build both shared and static libraries" OFF
  "BUILD_SHARED_LIBS" OFF)

# Expose options from the pugiconfig.hpp
option(PUGIXML_WCHAR_MODE "Enable wchar_t mode" OFF)
option(PUGIXML_COMPACT "Enable compact mode" OFF)

# Advanced options from pugiconfig.hpp
option(PUGIXML_NO_XPATH "Disable XPath" OFF)
option(PUGIXML_NO_STL "Disable STL" OFF)
option(PUGIXML_NO_EXCEPTIONS "Disable Exceptions" OFF)
mark_as_advanced(PUGIXML_NO_XPATH PUGIXML_NO_STL PUGIXML_NO_EXCEPTIONS)

# Policy configuration
if(POLICY CMP0091)
    cmake_policy(SET CMP0091 NEW) # Enables use of MSVC_RUNTIME_LIBRARY
endif()

set(PUGIXML_PUBLIC_DEFINITIONS
  $<$<BOOL:${PUGIXML_WCHAR_MODE}>:PUGIXML_WCHAR_MODE>
  $<$<BOOL:${PUGIXML_COMPACT}>:PUGIXML_COMPACT>
  $<$<BOOL:${PUGIXML_NO_XPATH}>:PUGIXML_NO_XPATH>
  $<$<BOOL:${PUGIXML_NO_STL}>:PUGIXML_NO_STL>
  $<$<BOOL:${PUGIXML_NO_EXCEPTIONS}>:PUGIXML_NO_EXCEPTIONS>)

# This is used to backport a CMake 3.15 feature, but is also forwards compatible
if (NOT DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
  set(CMAKE_MSVC_RUNTIME_LIBRARY
    MultiThreaded$<$<CONFIG:Debug>:Debug>$<$<NOT:$<BOOL:${PUGIXML_STATIC_CRT}>>:DLL>)
endif()

if (NOT DEFINED CMAKE_CXX_STANDARD_REQUIRED)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

if (NOT DEFINED CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 11)
endif()

if (PUGIXML_USE_POSTFIX)
  set(CMAKE_RELWITHDEBINFO_POSTFIX _r)
  set(CMAKE_MINSIZEREL_POSTFIX _m)
  set(CMAKE_DEBUG_POSTFIX _d)
endif()

if (CMAKE_VERSION VERSION_LESS 3.15)
  set(msvc-rt $<TARGET_PROPERTY:MSVC_RUNTIME_LIBRARY>)

  set(msvc-rt-mtd-shared $<STREQUAL:${msvc-rt},MultiThreadedDebugDLL>)
  set(msvc-rt-mtd-static $<STREQUAL:${msvc-rt},MultiThreadedDebug>)
  set(msvc-rt-mt-shared $<STREQUAL:${msvc-rt},MultiThreadedDLL>)
  set(msvc-rt-mt-static $<STREQUAL:${msvc-rt},MultiThreaded>)
  unset(msvc-rt)

  set(msvc-rt-mtd-shared $<${msvc-rt-mtd-shared}:-MDd>)
  set(msvc-rt-mtd-static $<${msvc-rt-mtd-static}:-MTd>)
  set(msvc-rt-mt-shared $<${msvc-rt-mt-shared}:-MD>)
  set(msvc-rt-mt-static $<${msvc-rt-mt-static}:-MT>)
endif()

set(versioned-dir $<$<BOOL:${PUGIXML_USE_VERSIONED_LIBDIR}>:/pugixml-${PROJECT_VERSION}>)

set(libs)

if (BUILD_SHARED_LIBS)
  add_library(pugixml-shared SHARED
    ${PROJECT_SOURCE_DIR}/scripts/pugixml_dll.rc
    ${PROJECT_SOURCE_DIR}/src/pugixml.cpp)
  add_library(pugixml::shared ALIAS pugixml-shared)
  list(APPEND libs pugixml-shared)

  set_property(TARGET pugixml-shared PROPERTY EXPORT_NAME shared)
  target_include_directories(pugixml-shared
    PUBLIC
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>)
  target_compile_definitions(pugixml-shared
    PUBLIC
      ${PUGIXML_BUILD_DEFINES}
      ${PUGIXML_PUBLIC_DEFINITIONS}
    PRIVATE
      $<$<CXX_COMPILER_ID:MSVC>:PUGIXML_API=__declspec\(dllexport\)>)
  target_compile_options(pugixml-shared
    PRIVATE
      ${msvc-rt-mtd-shared}
      ${msvc-rt-mtd-static}
      ${msvc-rt-mt-shared}
      ${msvc-rt-mt-static})
endif()

if (NOT BUILD_SHARED_LIBS OR PUGIXML_BUILD_SHARED_AND_STATIC_LIBS)
  add_library(pugixml-static STATIC
    ${PROJECT_SOURCE_DIR}/src/pugixml.cpp)
  add_library(pugixml::static ALIAS pugixml-static)
  list(APPEND libs pugixml-static)

  set_property(TARGET pugixml-static PROPERTY EXPORT_NAME static)
  target_include_directories(pugixml-static
    PUBLIC
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>)
  target_compile_definitions(pugixml-static
    PUBLIC
      ${PUGIXML_BUILD_DEFINES}
      ${PUGIXML_PUBLIC_DEFINITIONS})
  target_compile_options(pugixml-static
    PRIVATE
      ${msvc-rt-mtd-shared}
      ${msvc-rt-mtd-static}
      ${msvc-rt-mt-shared}
      ${msvc-rt-mt-static})
endif()

if (BUILD_SHARED_LIBS)
  set(pugixml-alias pugixml-shared)
else()
  set(pugixml-alias pugixml-static)
endif()
add_library(pugixml INTERFACE)
target_link_libraries(pugixml INTERFACE ${pugixml-alias})
add_library(pugixml::pugixml ALIAS pugixml)

set_target_properties(${libs}
  PROPERTIES
    MSVC_RUNTIME_LIBRARY ${CMAKE_MSVC_RUNTIME_LIBRARY}
    EXCLUDE_FROM_ALL ON
    POSITION_INDEPENDENT_CODE ON
    SOVERSION ${PROJECT_VERSION_MAJOR}
    VERSION ${PROJECT_VERSION}
    OUTPUT_NAME pugixml)

set_target_properties(${libs}
  PROPERTIES
    EXCLUDE_FROM_ALL OFF)
set(install-targets pugixml ${libs})

configure_package_config_file(
  "${PROJECT_SOURCE_DIR}/scripts/pugixml-config.cmake.in"
  "${PROJECT_BINARY_DIR}/pugixml-config.cmake"
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}
  NO_CHECK_REQUIRED_COMPONENTS_MACRO
  NO_SET_AND_CHECK_MACRO)

write_basic_package_version_file(
  "${PROJECT_BINARY_DIR}/pugixml-config-version.cmake"
  COMPATIBILITY SameMajorVersion)

if (PUGIXML_USE_POSTFIX)
  if(CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
    set(LIB_POSTFIX ${CMAKE_RELWITHDEBINFO_POSTFIX})
  elseif(CMAKE_BUILD_TYPE MATCHES MinSizeRel)
    set(LIB_POSTFIX ${CMAKE_MINSIZEREL_POSTFIX})
  elseif(CMAKE_BUILD_TYPE MATCHES Debug)
    set(LIB_POSTFIX ${CMAKE_DEBUG_POSTFIX})
  endif()
endif()

configure_file(scripts/pugixml.pc.in pugixml.pc @ONLY)

if (NOT DEFINED PUGIXML_RUNTIME_COMPONENT)
  set(PUGIXML_RUNTIME_COMPONENT Runtime)
endif()

if (NOT DEFINED PUGIXML_LIBRARY_COMPONENT)
  set(PUGIXML_LIBRARY_COMPONENT Library)
endif()

if (NOT DEFINED PUGIXML_DEVELOPMENT_COMPONENT)
  set(PUGIXML_DEVELOPMENT_COMPONENT Development)
endif()

set(namelink-component)
if (NOT CMAKE_VERSION VERSION_LESS 3.12)
  set(namelink-component NAMELINK_COMPONENT ${PUGIXML_DEVELOPMENT_COMPONENT})
endif()
install(TARGETS ${install-targets}
  EXPORT pugixml-targets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT ${PUGIXML_RUNTIME_COMPONENT}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT ${PUGIXML_LIBRARY_COMPONENT} ${namelink-component}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT ${PUGIXML_DEVELOPMENT_COMPONENT}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}${versioned-dir})

install(EXPORT pugixml-targets
  NAMESPACE pugixml::
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pugixml COMPONENT ${PUGIXML_DEVELOPMENT_COMPONENT})

export(EXPORT pugixml-targets
  NAMESPACE pugixml::)

install(FILES
  "${PROJECT_BINARY_DIR}/pugixml-config-version.cmake"
  "${PROJECT_BINARY_DIR}/pugixml-config.cmake"
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pugixml COMPONENT ${PUGIXML_DEVELOPMENT_COMPONENT})

install(FILES ${PROJECT_BINARY_DIR}/pugixml.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig COMPONENT ${PUGIXML_DEVELOPMENT_COMPONENT})

install(
  FILES
    "${PROJECT_SOURCE_DIR}/src/pugiconfig.hpp"
    "${PROJECT_SOURCE_DIR}/src/pugixml.hpp"
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}${versioned-dir} COMPONENT ${PUGIXML_DEVELOPMENT_COMPONENT})

if (PUGIXML_BUILD_TESTS)
  set(fuzz-pattern "tests/fuzz_*.cpp")
  set(test-pattern "tests/*.cpp")
  if (CMAKE_VERSION VERSION_GREATER 3.11)
    list(INSERT fuzz-pattern 0 CONFIGURE_DEPENDS)
    list(INSERT test-pattern 0 CONFIGURE_DEPENDS)
  endif()
  file(GLOB test-sources ${test-pattern})
  file(GLOB fuzz-sources ${fuzz-pattern})
  list(REMOVE_ITEM test-sources ${fuzz-sources})

  add_custom_target(check
    COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure)

  add_executable(pugixml-check ${test-sources})
  add_test(NAME pugixml::test
    COMMAND pugixml-check
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
  add_dependencies(check pugixml-check)
  target_link_libraries(pugixml-check
    PRIVATE
      pugixml::pugixml)
endif()

=== debian/changelog ===
pugixml (1.12.1-1) UNRELEASED; urgency=medium

  * update

 -- Vasudev Kamath <vasudev@copyninja.info>  Wed, 18 May 2022 22:45:44 -0400

pugixml (1.12.1-1) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * remove myself as uploader

  [ Gianfranco Costamagna ]
  * Convert to debhelper compat level 13
  * Fixup syntax for new cmake variables
  * Add R^3: no
  * Fix watch file and upgrade to v4
  * Bump std-version to 4.6.0
  * New upstream version 1.12.1
  * Patch refresh
  * Update copyright years
  * Drop dbgsym migration
  * Drop duplicated section in control file
  * Drop dbgsym migration code, useless now
  * Update copyright file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 23 Feb 2022 10:07:27 +0100

=== debian/control ===
Source: pugixml
Section: libs
Priority: optional
Build-Depends: cdbs,
 debhelper-compat (= 13),
 cmake,
 pkg-kde-tools
Maintainer: Vasudev Kamath <vasudev@copyninja.info>
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://pugixml.org/
Vcs-Git: https://salsa.debian.org/debian/pugixml.git
Vcs-Browser: https://salsa.debian.org/debian/pugixml

Package: libpugixml1v5
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Multi-Arch: same
Conflicts: libpugixml1
Replaces: libpugixml1
Description: Light-weight C++ XML processing library
 pugixml is a lightweight C++ XML processing library with XPath
 support. It features:
  * DOM like interface with rich traversal/modification capabilities
  * Extermely fast non-validating XML parser which constructs the DOM
    tree from an XML file/buffer.
  * XPath 1.0 implementation for complex data-driven tree queries
  * Full Unicode support with Unicode interface variants and automatic
    encoding conversions.
 .
 This library is extremely portable and easy to integrate and use.
 .
 Since pugixml has a DOM parser, it can't process XML documents that do
 not fit in memory; also the parser is a non-validating one, so if you
 need DTD or XML Schema validation, the library is not for you.

Package: libpugixml-dev
Section: libdevel
Architecture: any
Depends: libpugixml1v5 (= ${binary:Version}),
 ${misc:Depends},
 ${devlibs:Depends}
Multi-Arch: same
Description: Light-weight C++ XML processing library (development)
 pugixml is a lightweight C++ XML processing library with XPath
 support. It features:
  * DOM like interface with rich traversal/modification capabilities
  * Extermely fast non-validating XML parser which constructs the DOM
    tree from an XML file/buffer.
  * XPath 1.0 implementation for complex data-driven tree queries
  * Full Unicode support with Unicode interface variants and automatic
    encoding conversions.
 .
 This package provides required development header files which allows
 integrating pugixml with your application.

Package: pugixml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Light-weight C++ XML processing library (documentation)
 pugixml is a lightweight C++ XML processing library with XPath
 support. It features:
  * DOM like interface with rich traversal/modification capabilities
  * Extermely fast non-validating XML parser which constructs the DOM
    tree from an XML file/buffer.
  * XPath 1.0 implementation for complex data-driven tree queries
  * Full Unicode support with Unicode interface variants and automatic
    encoding conversions.
 .
 This package contains API documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/pkg-kde-tools/makefiles/1/cdbs/symbolshelper.mk

%:
	dh $@ --buildsystem=cmake

# Build the shared library
DEB_CMAKE_EXTRA_FLAGS += -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) -DBUILD_SHARED_LIBS=ON -DPUGIXML_BUILD_SHARED_AND_STATIC_LIBS=ON -DPUGIXML_USE_VERSIONED_LIBDIR=OFF
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
DEB_CMAKE_EXTRA_FLAGS += -DPUGIXML_BUILD_TESTS=1
endif

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

## pugixml 1.13

=== debian/changelog ===
pugixml (1.13-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Update symbols (Closes: #1015595)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 05 Dec 2022 20:21:58 +0100

pugixml (1.13-0.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Debian Janitor ]
  * Set upstream metadata fields: Security-Contact.
  * Drop unused build-dependency on cdbs.

  [ Jochen Sprickerhof ]
  * New upstream version 1.13
  * Rebase patches
  * Bump policy version (no changes)
  * Move package description to source package
  * Fix pkgkde-symbolshelper
  * Add new symbols
  * Drop unused lintian-overrides

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 05 Dec 2022 12:55:07 +0100

=== debian/control ===
Source: pugixml
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
 cmake,
 dh-sequence-pkgkde-symbolshelper,
Maintainer: Vasudev Kamath <vasudev@copyninja.info>
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://pugixml.org/
Vcs-Git: https://salsa.debian.org/debian/pugixml.git
Vcs-Browser: https://salsa.debian.org/debian/pugixml
Description: Light-weight C++ XML processing library
 pugixml is a lightweight C++ XML processing library with XPath
 support. It features:
  * DOM like interface with rich traversal/modification capabilities
  * Extermely fast non-validating XML parser which constructs the DOM
    tree from an XML file/buffer.
  * XPath 1.0 implementation for complex data-driven tree queries
  * Full Unicode support with Unicode interface variants and automatic
    encoding conversions.

Package: libpugixml1v5
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Multi-Arch: same
Conflicts: libpugixml1
Replaces: libpugixml1
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This library is extremely portable and easy to integrate and use.
 .
 Since pugixml has a DOM parser, it can't process XML documents that do
 not fit in memory; also the parser is a non-validating one, so if you
 need DTD or XML Schema validation, the library is not for you.

Package: libpugixml-dev
Section: libdevel
Architecture: any
Depends: libpugixml1v5 (= ${binary:Version}),
 ${misc:Depends},
 ${devlibs:Depends}
Multi-Arch: same
Description: ${source:Synopsis} (development)
 ${source:Extended-Description}
 .
 This package provides required development header files which allows
 integrating pugixml with your application.

Package: pugixml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: ${source:Synopsis} (documentation)
 ${source:Extended-Description}
 .
 This package contains API documentation.

## pugixml 1.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,11 @@
-cmake_minimum_required(VERSION 3.4)
-project(pugixml VERSION 1.12 LANGUAGES CXX)
+cmake_minimum_required(VERSION 3.5)
+
+# Policy configuration; this *MUST* be specified before project is defined
+if(POLICY CMP0091)
+    cmake_policy(SET CMP0091 NEW) # Enables use of MSVC_RUNTIME_LIBRARY
+endif()
+
+project(pugixml VERSION 1.14 LANGUAGES CXX)
 
 include(CMakePackageConfigHelpers)
 include(CMakeDependentOption)
@@ -43,11 +49,6 @@
 option(PUGIXML_NO_STL "Disable STL" OFF)
 option(PUGIXML_NO_EXCEPTIONS "Disable Exceptions" OFF)
 mark_as_advanced(PUGIXML_NO_XPATH PUGIXML_NO_STL PUGIXML_NO_EXCEPTIONS)
-
-# Policy configuration
-if(POLICY CMP0091)
-    cmake_policy(SET CMP0091 NEW) # Enables use of MSVC_RUNTIME_LIBRARY
-endif()
 
 set(PUGIXML_PUBLIC_DEFINITIONS
   $<$<BOOL:${PUGIXML_WCHAR_MODE}>:PUGIXML_WCHAR_MODE>
@@ -101,6 +102,10 @@
     ${PROJECT_SOURCE_DIR}/src/pugixml.cpp)
   add_library(pugixml::shared ALIAS pugixml-shared)
   list(APPEND libs pugixml-shared)
+  string(CONCAT pugixml.msvc $<OR:
+    $<STREQUAL:${CMAKE_CXX_COMPILER_FRONTEND_VARIANT},MSVC>,
+    $<CXX_COMPILER_ID:MSVC>
+  >)
 
   set_property(TARGET pugixml-shared PROPERTY EXPORT_NAME shared)
   target_include_directories(pugixml-shared
@@ -111,7 +116,8 @@
       ${PUGIXML_BUILD_DEFINES}
       ${PUGIXML_PUBLIC_DEFINITIONS}
     PRIVATE
-      $<$<CXX_COMPILER_ID:MSVC>:PUGIXML_API=__declspec\(dllexport\)>)
+      PUGIXML_API=$<IF:${pugixml.msvc},__declspec\(dllexport\),__attribute__\(\(visibility\("default"\)\)\)>
+    )
   target_compile_options(pugixml-shared
     PRIVATE
       ${msvc-rt-mtd-shared}

=== Makefile ===
.SUFFIXES:
MAKEFLAGS+=-r

config=debug
defines=standard
cxxstd=c++11
# set cxxstd=any to disable use of -std=...

BUILD=build/make-$(firstword $(CXX))-$(config)-$(defines)-$(cxxstd)

SOURCES=src/pugixml.cpp $(filter-out tests/fuzz_%,$(wildcard tests/*.cpp))
EXECUTABLE=$(BUILD)/test

VERSION=$(shell sed -n 's/.*version \(.*\).*/\1/p' src/pugiconfig.hpp)
RELEASE=$(filter-out scripts/archive.py docs/%.adoc,$(shell git ls-files docs scripts src CMakeLists.txt LICENSE.md readme.txt))

CXXFLAGS=-g -Wall -Wextra -Werror -pedantic -Wundef -Wshadow -Wcast-align -Wcast-qual -Wold-style-cast -Wdouble-promotion
LDFLAGS=

ifeq ($(config),release)
	CXXFLAGS+=-O3 -DNDEBUG
endif

ifeq ($(config),coverage)
	CXXFLAGS+=-coverage
	LDFLAGS+=-coverage
endif

ifeq ($(config),sanitize)
	CXXFLAGS+=-fsanitize=address,undefined -fno-sanitize=float-divide-by-zero,float-cast-overflow -fno-sanitize-recover=all
	LDFLAGS+=-fsanitize=address,undefined
endif

ifeq ($(config),analyze)
	CXXFLAGS+=--analyze
endif

ifneq ($(defines),standard)
	COMMA=,
	CXXFLAGS+=-D $(subst $(COMMA), -D ,$(defines))
endif

ifneq ($(findstring PUGIXML_NO_EXCEPTIONS,$(defines)),)
	CXXFLAGS+=-fno-exceptions
endif

ifneq ($(cxxstd),any)
	CXXFLAGS+=-std=$(cxxstd)
endif

OBJECTS=$(SOURCES:%=$(BUILD)/%.o)

all: $(EXECUTABLE)

ifeq ($(config),coverage)
test: $(EXECUTABLE)
	-@find $(BUILD) -name '*.gcda' -exec rm {} +
	./$(EXECUTABLE)
	@gcov -b -o $(BUILD)/src/ pugixml.cpp.gcda | sed -e '/./{H;$!d;}' -e 'x;/pugixml.cpp/!d;'
	@find . -name '*.gcov' -and -not -name 'pugixml.cpp.gcov' -exec rm {} +
	@sed -i -e "s/#####\(.*\)\(\/\/ unreachable.*\)/    1\1\2/" pugixml.cpp.gcov
else
test: $(EXECUTABLE)
	./$(EXECUTABLE)
endif

fuzz_%: $(BUILD)/fuzz_%
	@mkdir -p build/$@
	$< build/$@ tests/data_fuzz_$* -max_len=1024 -dict=tests/fuzz_$*.dict

clean:
	rm -rf $(BUILD)

release: build/pugixml-$(VERSION).tar.gz build/pugixml-$(VERSION).zip

docs: docs/quickstart.html docs/manual.html

build/pugixml-%: .FORCE | $(RELEASE)
	@mkdir -p $(BUILD)
	TIMESTAMP=`git show v$(VERSION) -s --format=%ct` && python3 scripts/archive.py $@ pugixml-$(VERSION) $$TIMESTAMP $|

$(EXECUTABLE): $(OBJECTS)
	$(CXX) $(OBJECTS) $(LDFLAGS) -o $@

$(BUILD)/fuzz_%: tests/fuzz_%.cpp src/pugixml.cpp
	@mkdir -p $(BUILD)
	$(CXX) $(CXXFLAGS) -fsanitize=address,fuzzer $^ -o $@

$(BUILD)/%.o: %
	@mkdir -p $(dir $@)
	$(CXX) $< $(CXXFLAGS) -c -MMD -MP -o $@

-include $(OBJECTS:.o=.d)

.SECONDEXPANSION:
docs/%.html: docs/%.adoc $$(shell sed -n 's/include\:\:\(.*\)\[.*/docs\/\1/p' docs/%.adoc)
	asciidoctor -b html5 -a version=$(VERSION) $< -o $@

.PHONY: all test clean release .FORCE

=== debian/changelog ===
pugixml (1.14-2) unstable; urgency=medium

  * Team upload
  * Fixup symbols file for 32 bit archs

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 06 Sep 2024 09:23:48 +0200

pugixml (1.14-1) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Bump std-version to 4.7.0
  * Add myself to copyright, to please lintian

  [ Aquila Macedo Costa <aquilamacedo@riseup.net> ]
  * Team upload.
  * Update symbols
  * Add lintian override for source-is-missing false positive

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 05 Sep 2024 17:55:40 +0200

pugixml (1.14-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream version 1.14
  * Update copyright years

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 03 Oct 2023 15:27:47 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
  cmake,
  dh-sequence-pkgkde-symbolshelper,
 Maintainer: Vasudev Kamath <vasudev@copyninja.info>
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://pugixml.org/
 Vcs-Git: https://salsa.debian.org/debian/pugixml.git

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,4 @@
 #!/usr/bin/make -f
-
-include /usr/share/pkg-kde-tools/makefiles/1/cdbs/symbolshelper.mk
 
 %:
 	dh $@ --buildsystem=cmake

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/pugixml-$1\.tar\.gz/ \
  https://github.com/zeux/pugixml/tags .*/v?(\d\S*)\.tar\.gz
